summaryrefslogtreecommitdiffstats
path: root/libraries/cglm
diff options
context:
space:
mode:
author Brian Hoffpauir <bhoffpauir0424@gmail.com>2023-07-08 10:25:26 +0700
committer Willy Sudiarto Raharjo <willysr@slackbuilds.org>2023-07-08 16:40:42 +0700
commitc6bbe9e1ac8a5fdcf0468b6171b083b1c57f44fc (patch)
tree6366cb0625d711140df5b3d4cea21f2269ad7642 /libraries/cglm
parentae99c6a9e9df497091e825e54ac849a6549b7119 (diff)
downloadslackbuilds-c6bbe9e1ac8a5fdcf0468b6171b083b1c57f44fc.tar.gz
slackbuilds-c6bbe9e1ac8a5fdcf0468b6171b083b1c57f44fc.tar.xz
libraries/cglm: Added (Graphics Math for C).
Signed-off-by: Willy Sudiarto Raharjo <willysr@slackbuilds.org>
Diffstat (limited to 'libraries/cglm')
-rw-r--r--libraries/cglm/README17
-rw-r--r--libraries/cglm/cglm.SlackBuild127
-rw-r--r--libraries/cglm/cglm.info10
-rw-r--r--libraries/cglm/slack-desc19
4 files changed, 173 insertions, 0 deletions
diff --git a/libraries/cglm/README b/libraries/cglm/README
new file mode 100644
index 0000000000..47ac7047a0
--- /dev/null
+++ b/libraries/cglm/README
@@ -0,0 +1,17 @@
+cglm is a highly optimizied 2D and 3D graphics math library for the C
+programming language. The library provides many utilities to help math
+operations stay fast while remainging easy to write. cglm is based on
+the GLM math library that has bindings for the C++ programming
+language. The library is primarily used for operations with the OpenGL
+graphics API. The complete documentation is available at
+http://cglm.readthedocs.io/.
+
+Optional dependency: Sphinx (for building documentation)
+
+The following options are available with the following default values:
+ CGLM_SHARED=ON # Shared library build
+ CGLM_STATIC=OFF # Static library build
+ CGLM_USE_C99=OFF # Use C11 by default
+ CGLM_USE_TEST=OFF # For make check/test
+ CGLM_BUILD_DOCS=NO # Set to YES to build documentation using Sphinx
+ You will need the sphinx_rtd_theme PyPI package
diff --git a/libraries/cglm/cglm.SlackBuild b/libraries/cglm/cglm.SlackBuild
new file mode 100644
index 0000000000..20f0550cf0
--- /dev/null
+++ b/libraries/cglm/cglm.SlackBuild
@@ -0,0 +1,127 @@
+#!/bin/bash
+#
+# ex:set ai shiftwidth=4 inputtab=spaces smarttab noautotab:
+
+# Slackware build script for cglm
+
+# Copyright 2023 Brian Hoffpauir, USA
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+cd $(dirname $0) ; CWD=$(pwd)
+
+PRGNAM=cglm
+VERSION=${VERSION:-0.9.0}
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+PKGTYPE=${PKGTYPE:-tgz}
+
+# OPTIONS
+CGLM_SHARED=${CGLM_SHARED:-ON}
+CGLM_STATIC=${CGLM_STATIC:-OFF}
+CGLM_USE_C99=${CGLM_USE_C99:-OFF}
+CGLM_USE_TEST=${CGLM_USE_TEST:-OFF}
+CGLM_BUILD_DOCS=${CGLM_BUILD_DOCS:-NO} # YES or NO
+
+if [ -z "$ARCH" ]; then
+ case "$(uname -m)" in
+ i?86) ARCH=i586 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$(uname -m) ;;
+ esac
+fi
+
+if [ ! -z "${PRINT_PACKAGE_NAME}" ]; then
+ echo "$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE"
+ exit 0
+fi
+
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+if [ "$ARCH" = "i586" ]; then
+ SLKCFLAGS="-O2 -march=i586 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+fi
+
+set -e
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP # Move into package directory
+rm -rf $PRGNAM-$VERSION # Erase prior source
+tar xvf $CWD/$PRGNAM-$VERSION.tar.gz
+cd $PRGNAM-$VERSION
+chown -R root:root . # Give everything to root user/group
+find -L . \
+ \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
+ -o -perm 511 \) -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
+ -o -perm 440 -o -perm 400 \) -exec chmod 644 {} \;
+
+mkdir -p build
+cd build
+cmake -G "Unix Makefiles" \
+ -DCMAKE_C_FLAGS:STRING="$SLKCFLAGS" \
+ -DCMAKE_CXX_FLAGS:STRING="$SLKCFLAGS" \
+ -DCMAKE_INSTALL_PREFIX=/usr \
+ -DLIB_SUFFIX=${LIBDIRSUFFIX} \
+ -DCMAKE_BUILD_TYPE=Release \
+ -DCGLM_SHARED=$CGLM_SHARED \
+ -DCGLM_STATIC=$CGLM_STATIC \
+ -DCGLM_USE_C99=$CGLM_USE_C99 \
+ -DCGLM_USE_TEST=$CGLM_USE_TEST ..
+
+make
+make install/strip DESTDIR=$PKG
+
+rm -f $PKG/{,usr/}lib${LIBDIRSUFFIX}/*.la
+
+if egrep -iq 'yes' <<< $CGLM_BUILD_DOCS; then
+ cd $TMP/$PRGNAM-$VERSION/docs
+
+ sphinx-build source build
+fi
+
+find $PKG -print0 | xargs -0 file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+if egrep -iq 'yes' <<< $CGLM_BUILD_DOCS; then
+ cp -a \
+ $TMP/$PRGNAM-$VERSION/docs/build/. \
+ $PKG/usr/doc/$PRGNAM-$VERSION
+fi
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE
diff --git a/libraries/cglm/cglm.info b/libraries/cglm/cglm.info
new file mode 100644
index 0000000000..922a8fe3dd
--- /dev/null
+++ b/libraries/cglm/cglm.info
@@ -0,0 +1,10 @@
+PRGNAM="cglm"
+VERSION="0.9.0"
+HOMEPAGE="https://github.com/recp/cglm"
+DOWNLOAD="https://github.com/recp/cglm/archive/refs/tags/v0.9.0/cglm-0.9.0.tar.gz"
+MD5SUM="a0b5d8007a977cb43a6f76ec0dfa9dff"
+DOWNLOAD_x86_64=""
+MD5SUM_x86_64=""
+REQUIRES=""
+MAINTAINER="Brian Hoffpauir"
+EMAIL="bhoffpauir0424@gmail.com"
diff --git a/libraries/cglm/slack-desc b/libraries/cglm/slack-desc
new file mode 100644
index 0000000000..f8bc59b405
--- /dev/null
+++ b/libraries/cglm/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description.
+# Line up the first '|' above the ':' following the base package name, and
+# the '|' on the right side marks the last column you can put a character in.
+# You must make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler------------------------------------------------------|
+cglm: cglm (Highly Optimized Graphics Math(glm) for C)
+cglm:
+cglm: cglm is a highly optimizied 2D and 3D graphics math library for the
+cglm: C programming language. The library provides many utilities to help
+cglm: math operations stay fast while remaining easy to write. gclm is
+cglm: based on the GLM math library that has bindings for the C++ program-
+cglm: ming language. The library is primarily used for operations with the
+cglm: OpenGL graphics API.
+cglm:
+cglm: Homepage: https://github.com/recp/cglm
+cglm: